function [H, S, C, H_hat, S_hat, C_hat] = L2n_parameters(N, M1, M2, ws, wp, Vr_hat, v_tilde, xs_hat)
% parameters for L2n
% Copyright (c) 2006 Yi Chen

syms w0 w1
H = zeros(size(Vr_hat'*Vr_hat));   

D = 2;
S = zeros(length(Vr_hat(1,:)),1);
C = 0;

% weighting function
weight = weight_sep(N, M1, M2, wp, ws);

% ideal diamond shape
H_ideal = 1-diamond(N+1,N+1);


for w0n = -pi:2*pi/N:pi-2*pi/N
    for w1n = -pi:2*pi/N:pi-2*pi/N
        
        vw = double(subs(v_tilde,[w0,w1],[w0n,w1n]));
        const = (2*pi/N)^2*weight(round((w0n+pi)/(2*pi/N))+1,round((w1n+pi)/(2*pi/N))+1);
        
        H = H + Vr_hat'*vw*vw'*Vr_hat*const;
    
        S = S + 2*Vr_hat'*vw*(1+xs_hat'*vw-D*H_ideal(round((w0n+pi)/(2*pi/N))+1,round((w1n+pi)/(2*pi/N))+1))*const;
    
        C = C + (1+xs_hat'*vw-D*H_ideal(round((w0n+pi)/(2*pi/N))+1,round((w1n+pi)/(2*pi/N))+1))^2*const;
    end
end

[Uh,Sh,Vh] = svd(H);

H_hat = sqrt(Sh)*Uh';
S_hat = 0.5*(pinv(sqrt(Sh))*inv(Uh))*S;
C_hat = C - S_hat'*S_hat;

clear D H_ideal M1 M2 N Sh Uh Vh Vr_hat const v_tilde vw w0 w0n w1 w1n weight ws xs_hat
